<h1 i18n="Control Center @@controlCenter">Control Center</h1>
<p i18n="@@controlCenterDescription">
  The control center lets system admins manage users, configure provider schemas, track statistics, and debug XAPI statements
</p>


<nz-tabset>


  <nz-tab [nzTitle]="tabTitleOverview">
    <ng-template i18n="Overview @@Overview" #tabTitleOverview>
      Übersicht
    </ng-template>

    <div class="statistic-container">
      <nz-card class="statistic-card" [nzBordered]="true">
      <nz-statistic [nzTitle]="'Number of Users'" [nzValue]="this.statistics?.user_count"></nz-statistic>
    </nz-card>
    <nz-card class="statistic-card" [nzBordered]="true">
      <nz-statistic [nzTitle]="'Number of Statements'" [nzValue]="this.statistics?.statement_count"></nz-statistic>
    </nz-card>
    <nz-card class="statistic-card" [nzBordered]="true">
      <nz-statistic [nzTitle]="'Number of Results'" [nzValue]="this.statistics?.result_count"></nz-statistic>
    </nz-card>

    <nz-card class="statistic-card" [nzBordered]="true">
      <div class="chart-container">
        <canvas #chartCanvas></canvas>
      </div>
    </nz-card>

  </div>

  </nz-tab>

  <nz-tab [nzTitle]="tabTitleUsers">
    <ng-template i18n="Users @@usersAndRoles" #tabTitleUsers>
      Users
    </ng-template>
    <nz-table
      #userTable
      [nzData]="this.users"
    >
      <thead>
      <tr>
        <th></th>
        <th>#</th>
        <th>Vorname</th>
        <th>Nachname</th>
        <th>E-Mail</th>
        <th>Admin</th>
        <th>Pausiert</th>
        <th>Datenschutzerklärung</th>
      </tr>
      </thead>
      <tbody>
      <ng-container *ngFor="let user of userTable.data">
        <tr>
          <td [nzExpand]="expandSet.has(user.id)"
              (nzExpandChange)="onExpandChange(user.id, $event)"></td>
          <td>{{user.id}}</td>
          <td>{{user.first_name}}</td>
          <td>{{user.last_name}}</td>
          <td>{{user.email}}</td>
          <td>{{user.is_superuser ? "ja" : "nein"}}</td>
          <td>{{user.paused_data_recording ? "ja" : "nein"}}</td>
          <td>{{user.general_privacy_policy ? "ja" : "nein"}}</td>
        </tr>
        <tr [nzExpand]="expandSet.has(user.id)">
          <td [attr.colspan]="8">
            <nz-tabset>
              <nz-tab nzTitle="Rollen">
                <h3>Rollen</h3>
                <nz-checkbox-group [(ngModel)]="user_group_checkboxes[user.id]" (ngModelChange)="user_permissions_changed[user.id] = true">
                </nz-checkbox-group>
                <button nz-button [disabled]="!user_permissions_changed[user.id]" style="float: right" (click)="saveUserPermissions(user.id)">Speichern</button>
              </nz-tab>
            </nz-tabset>

          </td>
        </tr>
      </ng-container>
      </tbody>
    </nz-table>
  </nz-tab>

  <nz-tab [nzTitle]="tabTitleProviders">
    <ng-template i18n="Provider Schemas | Provider Schemas header @@providerSchemas" #tabTitleProviders>
      Provider Schemas
    </ng-template>
    <app-provider [showTitle]="false">
    </app-provider>
  </nz-tab>

  <nz-tab [nzTitle]="tabTitlePrivacy">
    <ng-template i18n="Privacy Policy @@privacyPolicy" #tabTitlePrivacy>
      Privacy Policy
    </ng-template>
    <app-markdown-editor
      [markdownContent]="privacy_policy"
      (markdownChange)="updatePrivacyPolicy($event)"
    ></app-markdown-editor>
    <p></p>
    <button nz-button style="float: right" (click)="savePrivacyPolicy()">Datenschutzerklärung speichern</button>
  </nz-tab>

  <nz-tab [nzTitle]="tabTitlexAPI">
    <ng-template i18n="xAPI Tools @@xAPITools" #tabTitlexAPI>
      xAPI Tools
    </ng-template>
    <div class="xapi-tools-container">
      <h3 i18n="@@controlCenterxAPIStatementDebugger">
        xAPI Statement Debugger
      </h3>
      <p i18n="@@controlCenterDescription">
        Select a provider from the list and enter a statement to view the result of the rights engine.
      </p>
      <nz-select [(ngModel)]="selectedProvider" placeholder="Select Provider">
        <nz-option *ngFor="let provider of this.providers" [nzValue]="provider" [nzLabel]="provider.provider.name"></nz-option>
      </nz-select>
      <textarea rows="20" [(ngModel)]="xapiStatement" placeholder="Enter xAPI statement"></textarea>
      <nz-space>
      <button *nzSpaceItem nz-button nzType="primary" (click)="sendStatement()">Send Statement</button>
      <button *nzSpaceItem nz-button nzType="default" (click)="generateStatement()">Generate Statement</button>
      </nz-space>
      <div class="response-container" *ngIf="this.responseMessage">
        
        <nz-alert [nzType]="this.responseType" [nzMessage]="this.responseMessage" nzShowIcon></nz-alert>
      </div>
    </div>

    <div class="xapi-tools-container">
    <h3 i18n="@@controlCenterxAPIStatementDebugger">
      xAPI Statement Filter Debugger
    </h3>
    <p i18n="@@controlCenterDescription">
      Select an analytics from the list to execute the statement fetch that can be done by the analytics  
    </p>
    <nz-select [(ngModel)]="selectedAnalysis" placeholder="Select Analytics">
      <nz-option *ngFor="let provider of this.analyticsToken" [nzValue]="provider" [nzLabel]="provider.name"></nz-option>
    </nz-select>
    <textarea rows="10" [(ngModel)]="filterObject" placeholder="Filter Query"></textarea>
    <nz-space>
    <button *nzSpaceItem nz-button nzType="primary" (click)="sendFilter()">Get statements</button>
    </nz-space>
    <div class="response-container" *ngIf="this.responseStatementMessage">
        
      <nz-alert [nzType]="this.responseStatementType" [nzMessage]="this.responseStatementMessage" nzShowIcon></nz-alert>
    </div>
    </div>
  </nz-tab>



  <nz-tab [nzTitle]="tabTitleResultTools">
    <ng-template i18n="Analytics Result Tools @@ResultTools" #tabTitleResultTools>
      Analytics Result Tools
    </ng-template>
     <app-result-tools></app-result-tools>
  </nz-tab>  

</nz-tabset>
